### Hierarchy

- AtomItemsControl
  - AtomViewPager

### Implements

- IAtomComponent<IAtomElement>
- INotifyPropertyChanged

## Index

### Constructors

- constructor

### Properties

- allowMultipleSelection
- app
- autoScrollToSelection
- defaultControlStyle
- disposables
- element
- itemTemplate
- labelPath
- mAllowSelectFirst
- pendingInits
- sort
- uiVirtualize
- valuePath
- valueSeparator
- version
- isControl
- itemTemplate

### Accessors

- allowSelectFirst
- controlStyle
- data
- filter
- items
- itemsPresenter
- localViewModel
- parent
- selectAll
- selectedIndex
- selectedItem
- selectedItems
- theme
- value
- viewModel
- vsProps

### Methods

- append
- atomParent
- beginEdit
- bind
- bindEvent
- bringIntoView
- bringSelectionIntoView
- create
- createChild
- dispose
- disposeChildren
- hasItems
- hasProperty
- invalidate
- invalidateItems
- isSelected
- onCollectionChanged
- onCollectionChangedInternal
- onPropertyChanged
- onScroll
- onSelectedItemsChanged
- onUpdateSize
- onUpdateUI
- onVirtualCollectionChanged
- postVirtualCollectionChanged
- preCreate
- registerDisposable
- removeAllChildren
- render
- resetVirtualContainer
- resolve
- runAfterInit
- setElementClass
- setElementValue
- setLocalValue
- setPrimitiveValue
- toggleSelection
- unbind
- unbindEvent
- updateSelectionBindings
- updateSize
- validateScroller

## Constructors

### constructor

- new AtomViewPager(app: App, e?: HTMLElement): AtomViewPager

- Inherited from AtomControl.constructor

  Overrides AtomComponent.constructor

  - Defined in src/web/controls/AtomControl.ts:105

  #### Parameters

  - ##### app: App

  - ##### Optional e: HTMLElement

  #### Returns AtomViewPager

## Properties

### allowMultipleSelection

allowMultipleSelection: boolean

Inherited from AtomItemsControl.allowMultipleSelection

- Defined in src/web/controls/AtomItemsControl.ts:18

### app

app: App

Implementation of IAtomComponent.app

Inherited from AtomComponent.app

- Defined in src/core/AtomComponent.ts:133

### autoScrollToSelection

autoScrollToSelection: any

Inherited from AtomItemsControl.autoScrollToSelection

- Defined in src/web/controls/AtomItemsControl.ts:28

### defaultControlStyle

defaultControlStyle: any

Inherited from AtomControl.defaultControlStyle

- Defined in src/web/controls/AtomControl.ts:46

### disposables

disposables: AtomDisposableList

Inherited from AtomComponent.disposables

- Defined in src/core/AtomComponent.ts:45

### element

element: HTMLElement

Implementation of IAtomComponent.element

Inherited from AtomComponent.element

- Defined in src/core/AtomComponent.ts:47

### itemTemplate

itemTemplate: IClassOf<AtomControl>

Inherited from AtomItemsControl.itemTemplate

- Defined in src/web/controls/AtomItemsControl.ts:24

### labelPath

labelPath: string

Inherited from AtomItemsControl.labelPath

- Defined in src/web/controls/AtomItemsControl.ts:22

### mAllowSelectFirst

mAllowSelectFirst: boolean

Inherited from AtomItemsControl.mAllowSelectFirst

- Defined in src/web/controls/AtomItemsControl.ts:16

### Protected pendingInits

pendingInits: Array<function>

Inherited from AtomComponent.pendingInits

- Defined in src/core/AtomComponent.ts:49

### sort

sort: string | function

Inherited from AtomItemsControl.sort

- Defined in src/web/controls/AtomItemsControl.ts:30

### uiVirtualize

uiVirtualize: any

Inherited from AtomItemsControl.uiVirtualize

- Defined in src/web/controls/AtomItemsControl.ts:34

### valuePath

valuePath: string

Inherited from AtomItemsControl.valuePath

- Defined in src/web/controls/AtomItemsControl.ts:20

### valueSeparator

valueSeparator: string

Inherited from AtomItemsControl.valueSeparator

- Defined in src/web/controls/AtomItemsControl.ts:32

### version

version: number

Inherited from AtomItemsControl.version

- Defined in src/web/controls/AtomItemsControl.ts:26

### Static isControl

isControl: true = true

Inherited from AtomComponent.isControl

- Defined in src/core/AtomComponent.ts:42

### Static itemTemplate

itemTemplate: function = XNode.prepare("itemTemplate", true, true)

Inherited from AtomItemsControl.itemTemplate

- Defined in src/web/controls/AtomItemsControl.ts:14

Item Template for displaying individual items

#### Type declaration

- - (attributes: Partial<T>, ...nodes: XNode[]): XNode

  - #### Parameters

    - ##### attributes: Partial<T>

    - ##### Rest ...nodes: XNode[]

    #### Returns XNode

## Accessors

### allowSelectFirst

- set allowSelectFirst(b: any): void

- Inherited from AtomItemsControl.allowSelectFirst

  - Defined in src/web/controls/AtomItemsControl.ts:907

  #### Parameters

  - ##### b: any

  #### Returns void

### controlStyle

- get controlStyle(): AtomStyle
- set controlStyle(v: AtomStyle): void

- Inherited from AtomControl.controlStyle

  - Defined in src/web/controls/AtomControl.ts:49

  #### Returns AtomStyle

- Inherited from AtomControl.controlStyle

  - Defined in src/web/controls/AtomControl.ts:67

  #### Parameters

  - ##### v: AtomStyle

  #### Returns void

### data

- get data(): any
- set data(v: any): void

- Inherited from AtomComponent.data

  - Defined in src/core/AtomComponent.ts:56

  #### Returns any

- Inherited from AtomComponent.data

  - Defined in src/core/AtomComponent.ts:67

  #### Parameters

  - ##### v: any

  #### Returns void

### filter

- set filter(f: any): void

- Inherited from AtomItemsControl.filter

  - Defined in src/web/controls/AtomItemsControl.ts:912

  #### Parameters

  - ##### f: any

  #### Returns void

### items

- get items(): any[]
- set items(v: any[]): void

- Inherited from AtomItemsControl.items

  - Defined in src/web/controls/AtomItemsControl.ts:170

  #### Returns any[]

- Inherited from AtomItemsControl.items

  - Defined in src/web/controls/AtomItemsControl.ts:174

  #### Parameters

  - ##### v: any[]

  #### Returns void

### itemsPresenter

- get itemsPresenter(): HTMLElement
- set itemsPresenter(v: HTMLElement): void

- Inherited from AtomItemsControl.itemsPresenter

  - Defined in src/web/controls/AtomItemsControl.ts:98

  #### Returns HTMLElement

- Inherited from AtomItemsControl.itemsPresenter

  - Defined in src/web/controls/AtomItemsControl.ts:102

  #### Parameters

  - ##### v: HTMLElement

  #### Returns void

### localViewModel

- get localViewModel(): any
- set localViewModel(v: any): void

- Inherited from AtomComponent.localViewModel

  - Defined in src/core/AtomComponent.ts:94

  #### Returns any

- Inherited from AtomComponent.localViewModel

  - Defined in src/core/AtomComponent.ts:105

  #### Parameters

  - ##### v: any

  #### Returns void

### parent

- get parent(): AtomControl

- Inherited from AtomControl.parent

  Overrides AtomComponent.parent

  - Defined in src/web/controls/AtomControl.ts:99

  Gets Parent AtomControl of this control.

  #### Returns AtomControl

### selectAll

- set selectAll(v: any): void

- Inherited from AtomItemsControl.selectAll

  - Defined in src/web/controls/AtomItemsControl.ts:279

  #### Parameters

  - ##### v: any

  #### Returns void

### selectedIndex

- get selectedIndex(): number
- set selectedIndex(n: number): void

- Inherited from AtomItemsControl.selectedIndex

  - Defined in src/web/controls/AtomItemsControl.ts:226

  #### Returns number

- Inherited from AtomItemsControl.selectedIndex

  - Defined in src/web/controls/AtomItemsControl.ts:234

  #### Parameters

  - ##### n: number

  #### Returns void

### selectedItem

- get selectedItem(): any
- set selectedItem(value: any): void

- Inherited from AtomItemsControl.selectedItem

  - Defined in src/web/controls/AtomItemsControl.ts:191

  #### Returns any

- Inherited from AtomItemsControl.selectedItem

  - Defined in src/web/controls/AtomItemsControl.ts:198

  #### Parameters

  - ##### value: any

  #### Returns void

### selectedItems

- get selectedItems(): any[]
- set selectedItems(v: any[]): void

- Inherited from AtomItemsControl.selectedItems

  - Defined in src/web/controls/AtomItemsControl.ts:208

  #### Returns any[]

- Inherited from AtomItemsControl.selectedItems

  - Defined in src/web/controls/AtomItemsControl.ts:212

  #### Parameters

  - ##### v: any[]

  #### Returns void

### theme

- get theme(): AtomStyleSheet
- set theme(v: AtomStyleSheet): void

- Inherited from AtomControl.theme

  - Defined in src/web/controls/AtomControl.ts:86

  Represents associated AtomStyleSheet with this visual hierarchy. AtomStyleSheet is inherited by default.

  #### Returns AtomStyleSheet

- Inherited from AtomControl.theme

  - Defined in src/web/controls/AtomControl.ts:91

  Represents associated AtomStyleSheet with this visual hierarchy. AtomStyleSheet is inherited by default.

  #### Parameters

  - ##### v: AtomStyleSheet

  #### Returns void

### value

- get value(): any
- set value(v: any): void

- Inherited from AtomItemsControl.value

  - Defined in src/web/controls/AtomItemsControl.ts:107

  #### Returns any

- Inherited from AtomItemsControl.value

  - Defined in src/web/controls/AtomItemsControl.ts:136

  #### Parameters

  - ##### v: any

  #### Returns void

### viewModel

- get viewModel(): any
- set viewModel(v: any): void

- Inherited from AtomComponent.viewModel

  - Defined in src/core/AtomComponent.ts:73

  #### Returns any

- Inherited from AtomComponent.viewModel

  - Defined in src/core/AtomComponent.ts:84

  #### Parameters

  - ##### v: any

  #### Returns void

### vsProps

- get vsProps(): object | object | __type

- Inherited from AtomComponent.vsProps

  - Defined in src/core/AtomComponent.ts:119

  Do not ever use, only available as intellisense feature for vs code editor.

  #### Returns object | object | __type

## Methods

### append

- append(element: AtomControl | HTMLElement | Text): AtomControl

- Inherited from AtomControl.append

  Overrides AtomComponent.append

  - Defined in src/web/controls/AtomControl.ts:132

  #### Parameters

  - ##### element: AtomControl | HTMLElement | Text

  #### Returns AtomControl

### atomParent

- atomParent(e: HTMLElement): AtomControl

- Inherited from AtomControl.atomParent

  Overrides AtomComponent.atomParent

  - Defined in src/web/controls/AtomControl.ts:121

  #### Parameters

  - ##### e: HTMLElement

  #### Returns AtomControl

### beginEdit

- beginEdit(): IDisposable

- Inherited from AtomComponent.beginEdit

  - Defined in src/core/AtomComponent.ts:386

  #### Returns IDisposable

### bind

- bind(element: HTMLElement, name: string, path: PathList[], twoWays?: boolean | string[], valueFunc?: function, source?: any): IDisposable

- Inherited from AtomComponent.bind

  - Defined in src/core/AtomComponent.ts:148

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### path: PathList[]

  - ##### Optional twoWays: boolean | string[]

  - ##### Optional valueFunc: function

    - - (...v: any[]): any

      - #### Parameters

        - ##### Rest ...v: any[]

        #### Returns any

  - ##### Optional source: any

  #### Returns IDisposable

### bindEvent

- bindEvent(element: HTMLElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): IDisposable

- Inherited from AtomComponent.bindEvent

  - Defined in src/core/AtomComponent.ts:186

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns IDisposable

### bringIntoView

- bringIntoView(data: any): void

- Inherited from AtomItemsControl.bringIntoView

  - Defined in src/web/controls/AtomItemsControl.ts:574

  #### Parameters

  - ##### data: any

  #### Returns void

### bringSelectionIntoView

- bringSelectionIntoView(): void

- Inherited from AtomItemsControl.bringSelectionIntoView

  - Defined in src/web/controls/AtomItemsControl.ts:588

  #### Returns void

### Protected create

- create(): void

- Overrides AtomComponent.create

  - Defined in src/web/controls/AtomViewPager.ts:27

  #### Returns void

### Protected createChild

- createChild(df: DocumentFragment, data: any): AtomControl

- Inherited from AtomItemsControl.createChild

  - Defined in src/web/controls/AtomItemsControl.ts:1017

  #### Parameters

  - ##### df: DocumentFragment

  - ##### data: any

  #### Returns AtomControl

### dispose

- dispose(e?: HTMLElement): void

- Overrides AtomItemsControl.dispose

  - Defined in src/web/controls/AtomViewPager.ts:13

  #### Parameters

  - ##### Optional e: HTMLElement

  #### Returns void

### Protected disposeChildren

- disposeChildren(e: HTMLElement): void

- Inherited from AtomItemsControl.disposeChildren

  - Defined in src/web/controls/AtomItemsControl.ts:1035

  #### Parameters

  - ##### e: HTMLElement

  #### Returns void

### hasItems

- hasItems(): boolean

- Inherited from AtomItemsControl.hasItems

  - Defined in src/web/controls/AtomItemsControl.ts:658

  #### Returns boolean

### hasProperty

- hasProperty(name: string): boolean

- Implementation of IAtomComponent.hasProperty

  Inherited from AtomItemsControl.hasProperty

  Overrides AtomComponent.hasProperty

  - Defined in src/web/controls/AtomItemsControl.ts:245

  #### Parameters

  - ##### name: string

  #### Returns boolean

### invalidate

- invalidate(): void

- Inherited from AtomComponent.invalidate

  - Defined in src/core/AtomComponent.ts:406

  #### Returns void

### invalidateItems

- invalidateItems(): void

- Inherited from AtomItemsControl.invalidateItems

  - Defined in src/web/controls/AtomItemsControl.ts:662

  #### Returns void

### isSelected

- isSelected(item: any): boolean

- Inherited from AtomItemsControl.isSelected

  - Defined in src/web/controls/AtomItemsControl.ts:563

  #### Parameters

  - ##### item: any

  #### Returns boolean

### onCollectionChanged

- onCollectionChanged(): void

- Overrides AtomItemsControl.onCollectionChanged

  - Defined in src/web/controls/AtomViewPager.ts:23

  #### Returns void

### Protected onCollectionChangedInternal

- onCollectionChangedInternal(key: string, index: number, item: any): void

- Inherited from AtomItemsControl.onCollectionChangedInternal

  - Defined in src/web/controls/AtomItemsControl.ts:877

  #### Parameters

  - ##### key: string

  - ##### index: number

  - ##### item: any

  #### Returns void

### onPropertyChanged

- onPropertyChanged(name: string): void

- Implementation of INotifyPropertyChanged.onPropertyChanged

  Inherited from AtomItemsControl.onPropertyChanged

  Overrides AtomControl.onPropertyChanged

  - Defined in src/web/controls/AtomItemsControl.ts:258

  #### Parameters

  - ##### name: string

  #### Returns void

### Protected onScroll

- onScroll(): void

- Inherited from AtomItemsControl.onScroll

  - Defined in src/web/controls/AtomItemsControl.ts:921

  #### Returns void

### onSelectedItemsChanged

- onSelectedItemsChanged(type: any, index: any, item: any): void

- Inherited from AtomItemsControl.onSelectedItemsChanged

  - Defined in src/web/controls/AtomItemsControl.ts:645

  #### Parameters

  - ##### type: any

  - ##### index: any

  - ##### item: any

  #### Returns void

### Protected onUpdateSize

- onUpdateSize(): void

- Inherited from AtomControl.onUpdateSize

  - Defined in src/web/controls/AtomControl.ts:301

  #### Returns void

### onUpdateUI

- onUpdateUI(): void

- Inherited from AtomComponent.onUpdateUI

  - Defined in src/core/AtomComponent.ts:418

  #### Returns void

### onVirtualCollectionChanged

- onVirtualCollectionChanged(): void

- Inherited from AtomItemsControl.onVirtualCollectionChanged

  - Defined in src/web/controls/AtomItemsControl.ts:312

  #### Returns void

### postVirtualCollectionChanged

- postVirtualCollectionChanged(): void

- Inherited from AtomItemsControl.postVirtualCollectionChanged

  - Defined in src/web/controls/AtomItemsControl.ts:306

  #### Returns void

### Protected preCreate

- preCreate(): void

- Inherited from AtomItemsControl.preCreate

  Overrides AtomControl.preCreate

  - Defined in src/web/controls/AtomItemsControl.ts:860

  #### Returns void

### registerDisposable

- registerDisposable(d: IDisposable): IDisposable

- Inherited from AtomComponent.registerDisposable

  - Defined in src/core/AtomComponent.ts:430

  #### Parameters

  - ##### d: IDisposable

  #### Returns IDisposable

### Protected removeAllChildren

- removeAllChildren(e: HTMLElement): void

- Inherited from AtomControl.removeAllChildren

  - Defined in src/web/controls/AtomControl.ts:305

  #### Parameters

  - ##### e: HTMLElement

  #### Returns void

### Protected render

- render(node: XNode, e?: any, creator?: any): void

- Inherited from AtomComponent.render

  - Defined in src/core/AtomComponent.ts:434

  #### Parameters

  - ##### node: XNode

  - ##### Optional e: any

  - ##### Optional creator: any

  #### Returns void

### resetVirtualContainer

- resetVirtualContainer(): void

- Inherited from AtomItemsControl.resetVirtualContainer

  - Defined in src/web/controls/AtomItemsControl.ts:294

  #### Returns void

### Protected resolve

- resolve<TService>(c: TService, selfName?: string | function): IAnyInstanceType<TService>

- Inherited from AtomComponent.resolve

  - Defined in src/core/AtomComponent.ts:525

  #### Type parameters

  - #### TService

  #### Parameters

  - ##### c: TService

  - ##### Optional selfName: string | function

  #### Returns IAnyInstanceType<TService>

### runAfterInit

- runAfterInit(f: function): void

- Inherited from AtomComponent.runAfterInit

  - Defined in src/core/AtomComponent.ts:422

  #### Parameters

  - ##### f: function

    - - (): void

      - #### Returns void

### Protected setElementClass

- setElementClass(element: HTMLElement, value: any, clear?: boolean): void

- Inherited from AtomControl.setElementClass

  - Defined in src/web/controls/AtomControl.ts:263

  #### Parameters

  - ##### element: HTMLElement

  - ##### value: any

  - ##### Optional clear: boolean

  #### Returns void

### Protected setElementValue

- setElementValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomControl.setElementValue

  Overrides AtomComponent.setElementValue

  - Defined in src/web/controls/AtomControl.ts:158

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### value: any

  #### Returns void

### setLocalValue

- setLocalValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomComponent.setLocalValue

  - Defined in src/core/AtomComponent.ts:306

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### value: any

  #### Returns void

### setPrimitiveValue

- setPrimitiveValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomComponent.setPrimitiveValue

  - Defined in src/core/AtomComponent.ts:271

  Use this method if you want to set attribute on HTMLElement immediately but defer atom control property

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement

  - ##### name: string

    string

  - ##### value: any

    any

  #### Returns void

### Protected toggleSelection

- toggleSelection(data: any): void

- Inherited from AtomItemsControl.toggleSelection

  - Defined in src/web/controls/AtomItemsControl.ts:931

  #### Parameters

  - ##### data: any

  #### Returns void

### unbind

- unbind(element: HTMLElement, name?: string): void

- Inherited from AtomComponent.unbind

  - Defined in src/core/AtomComponent.ts:178

  Remove all bindings associated with given element and optional name

  #### Parameters

  - ##### element: HTMLElement

    T

  - ##### Optional name: string

    string

  #### Returns void

### unbindEvent

- unbindEvent(element: HTMLElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): void

- Inherited from AtomComponent.unbindEvent

  - Defined in src/core/AtomComponent.ts:216

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns void

### updateSelectionBindings

- updateSelectionBindings(): void

- Inherited from AtomItemsControl.updateSelectionBindings

  - Defined in src/web/controls/AtomItemsControl.ts:628

  #### Returns void

### updateSize

- updateSize(): void

- Inherited from AtomControl.updateSize

  - Defined in src/web/controls/AtomControl.ts:141

  #### Returns void

### Protected validateScroller

- validateScroller(): void

- Inherited from AtomItemsControl.validateScroller

  - Defined in src/web/controls/AtomItemsControl.ts:948

  #### Returns void

Generated using TypeDoc